\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}
\usepackage[bottom]{footmisc}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 2b - Become multihomed}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 2b - Become multihomed}
\date{Version 2.0}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle
\section{Introduction}
In this experiment we add a 2nd upstream provider and also a peering connection to our BGP setup and monitor how BGP attributes are received and how our router selects a best path to destination prefixes.

\section{Network Setup}
\subsection{IPv4}
\begin{figure}[htp]
  \includegraphics[width=\linewidth,page=2]{img/02-ebgp-drawings.pdf}
  \caption{Network Setup for IPv4}
  \label{fig:networksetupv4}
\end{figure}
Figure \ref{fig:networksetupv4} shows the network topology and IPv4 addressing for this experiment.
Participants are using AS645xx  and are connected to AS65550 and AS64496 as upstreams and to a peering LAN.

\subsection{IPv6}
\begin{figure}[htp]
  \includegraphics[width=\linewidth,page=3]{img/02-ebgp-drawings.pdf}
  \caption{Network Setup for IPv6}
  \label{fig:networksetupv6}
\end{figure}
Figure \ref{fig:networksetupv6} shows the network topology and IPv6 addressing for this experiment.
Participants are using AS645xx  and are connected to AS65550 and AS64496 as upstreams and to a peering LAN. Note that IPv6 addressing in the peering LAN is derived from the AS number - AS64501 converts to fbf5 as part of the IPv6 address (for the fixed peer AS286 this is not possible because of Docker).

\section{Slides}

%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Add a 2nd upstream: IPv4}
\LARGE
\begin{itemize}
  \item We already have a peer group for IPv4 upstreams: \emph{upstream-v4}
  \item We simply add a 2nd member to that group.
\end{itemize}

\vspace{1cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
 neighbor 10.230.x.1 remote-as 64496
 neighbor 10.230.x.1 peer-group upstream-v4
\end{verbatim}
\end{framed}

Now check again for BGP summary and received prefixes.

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 neighbor 10.200.x.1 routes
  \item show bgp ipv4 neighbor 10.200.x.1 received-routes
  \item show bgp ipv4 neighbor 10.230.x.1 routes
  \item show bgp ipv4 neighbor 10.230.x.1 received-routes
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Add a 2nd upstream: IPv6}
\LARGE

\begin{itemize}
  \item Doing this for IPv6 is just as easy
  \item Simply add a 2nd member to the IPv6 peer-group: \emph{upstream-v6}
\end{itemize}

\vspace{1cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
 neighbor 2001:db8:230:x::1 remote-as 64496
 neighbor 2001:db8:230:x::1 peer-group upstream-v6
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv6 summary
  \item show bgp ipv6
  \item show bgp ipv6 neighbor 2001:db8:200:x::1 routes
  \item show bgp ipv6 neighbor 2001:db8:200:x::1 received-routes
  \item show bgp ipv6 neighbor 2001:db8:230:x::1 routes
  \item show bgp ipv6 neighbor 2001:db8:230:x::1 received-routes
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Add IPv4-Peering}
\LARGE
\begin{itemize}
  \item We need a new peer group for peering
  \item And new route-maps
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
route-map peering-in permit 100
route-map peering-out deny 100

router bgp 645xx
 neighbor peering-v4 peer-group
 address-family ipv4 unicast
  neighbor peering-v4 soft-reconfig inbound
  neighbor peering-v4 route-map peering-in in
  neighbor peering-v4 route-map peering-out out
  neighbor peering-v4 activate
 exit-address-family
 neighbor 80.81.192.1 remote-as 286
 neighbor 80.81.192.1 peer-group peering-v4
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \begin{itemize}
    \item which prefixes are "best"? (marked with ">")
    \item is it always peering?
  \end{itemize}
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Add IPv6 Peering}
\LARGE
\begin{itemize}
  \item Again we need a \emph{different} peergroup for IPv6 peering
  \item but we use the same route-maps
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
 neighbor peering-v6 peer-group
 address-family ipv6 unicast
  neighbor peering-v6 soft-reconfig inbound
  neighbor peering-v6 route-map peering-in in
  neighbor peering-v6 route-map peering-out out
  neighbor peering-v6 activate
 exit-address-family
 neighbor 2001:7f8::0:1 remote-as 286
 neighbor 2001:7f8::0:1 peer-group peering-v6
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv6 summary
  \item show bgp ipv6
\end{itemize}

Which prefixes are ``best''? Why?

\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Setting local preference}
\LARGE
\begin{itemize}
  \item We want to prefer peering over upstream
  \item For this we adjust \emph{Local Preference}
  \item \emph{Local Preference} is a configured BGP attribute
  \item Higher value == better
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
route-map peering-in permit 100
 set local-preference 1000

route-map upstream-in permit 100
 set local-preference 10
\end{verbatim}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv4
  \item show bgp ipv6
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Peer with each other - IPv4}
\LARGE
\begin{itemize}
  \item We can now setup peering between all routers
  \item Just add them to the \emph{peering} peer-group (for IPv4)
  \item For IPv6 add them to the \emph{peering-v6} peer-group
\end{itemize}
\vspace{0.5cm}

\begin{framed}
\begin{verbatim}
router bgp 645xx
 neighbor 80.81.192.1yy remote-as 645yy
 neighbor 80.81.192.1yy peer-group peering-v4
 neighbor 80.81.192.1zz remote-as 645zz
 neighbor 80.81.192.1zz peer-group peering-v4
 ...
\end{verbatim}
\end{framed}
\ldots with yy, zz = 01, 02, 03, \ldots

\vspace{0.5cm}
\begin{framed}
\begin{verbatim}
router bgp 645xx
 neighbor 2001:7f8::yhex:0:1 remote-as 645yy
 neighbor 2001:7f8::yhex:0:1 peer-group peering-v6
 neighbor 2001:7f8::zhex:0:1 remote-as 645zz
 neighbor 2001:7f8::zhex:0:1 peer-group peering-v6
 ...
\end{verbatim}
\end{framed}
For IPv6 you need to convert your neighbors AS number into hexadecimal (yhex, zhex).
\begin{tabularx}{14cm}{llll}
64501 = fbf5 & 64504 = fbf8 &  64507 = fbfb &  64510 = fbfe\\
64502 = fbf6 & 64505 = fbf9 &  64508 = fbfc &  64511 = fbff \\
64503 = fbf7 & 64506 = fbfa &  64509 = fbfd & 64512 = fc00\\
\end{tabularx}
Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv6 summary
\end{itemize}

\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Inject a prefix into BGP}
\LARGE
\begin{itemize}
  \item Do you remember how we did that with iBGP?
  \item We must get it into the routing table
  \item We use a static route for this
  \item Then must get the prefix into BGP
  \item Again we use a \emph{network} statement
\end{itemize}

\subsubsection*{\LARGE For IPv4:}
\begin{framed}
\begin{verbatim}
ip route 192.168.n.0/24 dummy0
router bgp 645xx
 address-family ipv4 unicast
  network 192.168.n.0/24
\end{verbatim}
\end{framed}

\subsubsection*{\LARGE For IPv6:}
\begin{framed}
\begin{verbatim}
ipv6 route 2001:7f8:99:xx::/48  dummy0
router bgp 645xx
 address-family ipv6 unicast
  network 2001:7f8:99:xx::/48
\end{verbatim}
\end{framed}


Show commands:
\begin{itemize}
  \item show bgp ipv4 192.168.n.0/24
  \item show bgp ipv6 2001:7f8:99:xx::/48
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Announcing our prefixes (the wrong way)}
\LARGE
\begin{itemize}
  \item We have the prefixes now in BGP but they are not announced
  \item We have a route-map in place preventing this
  \item So we must change it and allow \emph{only our} prefixes out.
  \item With FRRouting it is important to know that each config line entered becomes active immediately. So take care about the order of entering.
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
! do not do this - listen and wait !
!
ip prefix-list my-prefixes permit 192.168.n.0/24
ipv6 prefix-list my-prefixes permit 2001:7f8:99:xx::/48

route-map peering-out permit 50
! what happens if you go for a coffee now?
 match ip address prefix-list my-prefixes

route-map peering-out permit 60
 match ipv6 address prefix-list my-prefixes

route-map upstream-out permit 50
 match ip address prefix-list my-prefixes

route-map upstream-out permit 60
 match ipv6 address prefix-list my-prefixes
\end{verbatim}
\end{framed}

\end{samepage}
\clearpage
%----------------------------------------------------------------
\begin{samepage}
\subsection*{\Huge Announcing our prefixes (the right way)}
\Large
\begin{itemize}
  \item With FRRouting it is important to know that each config line entered becomes active immediately. So take care about the order of entering.
  \item We set the ``allow'' statements \emph{behind} the deny ones
  \item Then we remove the deny statement
  \item At the end is always an implicit deny
\end{itemize}
\vspace{0.5cm}

\begin{framed}
\begin{verbatim}
ip prefix-list my-prefixes permit 192.168.n.0/24
ipv6 prefix-list my-prefixes permit 2001:7f8:99:xx::/48

route-map peering-out permit 200
 match ip address prefix-list my-prefixes

route-map peering-out permit 250
 match ipv6 address prefix-list my-prefixes

route-map upstream-out permit 200
 match ip address prefix-list my-prefixes

route-map upstream-out permit 250
 match ipv6 address prefix-list my-prefixes

no route-map peering-out deny 100
no route-map upstream-out deny 100
\end{verbatim}
\end{framed}
Show commands:
\begin{itemize}
  \item show bgp ipv4 \\(to see what others are announcing)
  \item show bgp ipv4 neighbor 80.81.192.101 advertised \\(to see what yourself are annoucing)
\end{itemize}
\end{samepage}
\clearpage
%----------------------------------------------------------------
%----------------------------------------------------------------

\section{Setup eBGP}
\subsection{To set up eBGP you need to:}
\begin{itemize}
  \item configure four peer-groups:
  \begin{itemize}
    \item two peer-groups for upstreams (v4 and v6)
    \item two peer-groups for peering (v4 and v6)
  \end{itemize}
  \item configure (empty) filters for both (peering-in, peering-out, upstream-in, upstream-out)
  \item configure neighbors as peer-group members
\end{itemize}

Information you need:
\begin{itemize}
  \item Your AS number is 645xx (with xx from 01 to 15)
  \item Your upstream providers AS numbers are 65550 (with IPv4 address network 10.200.x.1) and 64496 (with 10.230.x.1)
  \item For peering we are using IP addresses from DE-CIX Frankfurt. Your peer is AS286 with IP 80.81.191.1, your IP address is 80.81.192.1xx/21 (with \emph{xx} being the same as your router number).
\end{itemize}

For IPv6:
\begin{itemize}
  \item The AS numbers of your upstream providers are the same as in ipv4
  \item AS64496 is at 2001:db8:230:xx::1
  \item AS65550 is at 2001:db8:200:xx::1
  \item your peer AS286 is at 2001:7f8::1
  \item your own IPv6 address for peering is 2001:7f8::\emph{<ashex>}:0:1, with \emph{<ashex>} being your AS number in hexadecimal.
\end{itemize}

\subsection{To configure eBGP in config mode:}
\begin{description}
  \item[neighbor <name> peer-group] starts a peer group named \emph{<name>}
  \item[neighbor <name> route-map <rmname> in/out] filters all prefixes in or out through route-map \emph{<rmname>}. If the route-map is not defined (or if there is a typo in the name) it blocks everyhting in or out.
  \item[neighbor <name> soft-reconfiguration inbound] allows you to see (via \emph{show bgp ipv4/ipv6 neighbor <address> received-routes}) what the router receives before the incoming route-map is processed.
  \item[neighbor <name> send-community both] tells BGP to send communities, needed later.
  \item[neighbor <ip-address> remote-as <asnumber>] sets up an neighbor with IP \emph{<ip-address>} and AS \emph{<asnumber>}. This command becomes active as soon as it is entered, so if you want to enter more config items for this peer, you either be quick or you need to shut it down until config is complete.
  \item[neighbor <ip-address> shutdown] shuts down the BGP connection to this neibbor. Useful when you want to take some time configuring.
\end{description}
The remote AS is not configured in the peer-group but in the peer-group member, as you might want to re-use the same peer-group for more then one upstream provider.

\subsection{Commands to check your eBGP session:}
\begin{description}
\item[show bgp ipv4/ipv6 summary] give you information about your peers
\item[show bgp ipv4/ipv6 neighbor <ip-address>] gives you detailed information about BGP neighbor with IP \emph{<ip-address>}. If you ommit the IP lists all neigbors very detailed (long output).
\item[show bgp ipv4/ipv6] lists all prefixes in BGP. Be aware that once you are on a real router connected to the real internet the output can be very longer
\item[show bgp ipv4/ipv6 <prefix>] gives you detailed BGP information about IP  \emph{<prefix>}
\item[show bgp ipv4/ipv6 neighbor <ip-address> routes] shows all valid routes received from a specific neighbor (after the filters).
\item[show bgp ipv4/ipv6 neighbor <ip-address> received-routes] shows all routes received from a specific neighbor (before filters are applied). Useful for checking if your filters work.
\item[show bgp ipv4/ipv6 neighbor <ip-address> advertised-routes] shows all prefixes advertised to a specific neighbor.
\end{description}

\subsection{Tasks:}
\begin{itemize}
  \item Define two peer groups for eBGP upstream neighbors (if not already done) - one for IPv4 and one for IPv6
  \item Set up an eBGP session to AS65550 using IPv4
  \item Set up an eBGP session to AS64496 using IPv4
  \item Check if the sessions come up
  \item Look if you are receiving anything
  \item define (empty) route-maps for in and out for upstream
  \item Check again for received prefixes
  \item Define a peer group for eBGP peering
  \item Set up an eBGP session to AS286
  \item define (empty) route-maps for in and out for peering
  \item Try all commands listed above and look for anything unusual.
  \item do the same for IPv6
\end{itemize}

Answer the following questions:
\begin{itemize}
  \item Are there any prefixes sent which your router does not accept?
  \item Why?
  \item Which routes to a given prefix are ``best''?
  \item What criteria is used to make a prefix ``best''?
\end{itemize}

\section{Setup peering with all other participants}
\subsection{To set up peering you need to:}
\begin{itemize}
  \item create peer-groups \emph{peering} and \emph{peering-v6}(if you have not already done so)
  \item configure neighbors to all other participants using these peer-groups.
\end{itemize}

\subsection{Information you need:}
\begin{itemize}
  \item AS numbers are 645xx (with xx from 01 to 20)
  \item IPv4 addresses are 80.81.192.1xx (with xx same as in AS)
  \item IPv6 addresses are 2001:7f8::YYYY:0:1 - with YYYY being the AS number. (AS64501 == fbf5).
\end{itemize}

\section{Optimize Routing}
\subsection{Routing Policy}
We want to implement the following very simple routing policy in this experiment:
\begin{itemize}
  \item Prefer peering over upstream
\end{itemize}

\subsection{Config statements you need}
\begin{description}
  \item[route-map <name> permit/deny <number>] starts a route-map statement for a named route-map. Each route-map is referenced by \emph{<name>} and statements are processed in order, starting with the lowest \emph{<number>}. Inside each statement there can be zero to multiple \emph{match} and \emph{set} clauses.
  If the statement is evaluated true (all match conditions are true) permit or deny is executed. If not (matches evaluate false) the next statement in order is processed. If there are no statements left, there is an implicit deny at the end.
  \item[match <condition>] An empty/missing \emph{match} is always true. If there are multiples \emph{match} statements, they all must be true for the entry to be true.
  \item[set <parameter> <value>] If all matches are true (or if there are no match statements), all \emph{set} statements are executed, the route-map is terminated and either permit or deny is executed (depending on the value in the statement header).
  \item[set local-preference \emph{value}] this sets the local preference of prefixes to value. It is only executed if there is either no \emph{match} statement or if \emph{all} match statements evaluate true.
\end{description}

\subsection{Implementation}
We are using \emph{local preference} to influence the routers best prefix selection. Local preference is the very first decision parameter in the best path selection algorithm.

Where to set \emph{local preference}? This is what route maps are for. We add statements to the already existing (but empty) incoming route maps.

\subsection{Tasks}
\begin{itemize}
  \item Set the local preference of all prefixes received via peering to 1000
  \item Set local preference of all prefixes receive via upstream to 10
\end{itemize}

\section{Solutions}
\subsection{Solution for FRRouting}
\begin{minipage}{\textwidth}
\subsubsection{Configure two IPv4 upstreams}
\begin{verbatim}
router bgp 645xx
 bgp ebgp-requires-policy
 no bgp default ipv4-unicast
 neighbor upstream-v4 peer-group
 neighbor 10.200.xx.1 remote-as 65550
 neighbor 10.200.xx.1 peer-group upstream-v4
 neighbor 10.230.xx.1 remote-as 64496
 neighbor 10.230.xx.1 peer-group upstream-v4
 address-family ipv4 unicast
  neighbor upstream-v4 soft-reconfiguration inbound
  neighbor upstream-v4 route-map upstream-in in
  neighbor upstream-v4 route-map upstream-out out
  neighbor upstream-v4 activate
 exit-address-family
!
route-map upstream-out deny 100
!
route-map upstream-in permit 100
!
\end{verbatim}

\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Configure two IPv6 upstreams}
\begin{verbatim}
router bgp 645xx
 bgp ebgp-requires-policy
 no bgp default ipv4-unicast
 neighbor upstream-v6 peer-group
 neighbor 2001:db8:200:xx::1 remote-as 65550
 neighbor 2001:db8:200:xx::1 peer-group upstream-v6
 neighbor 2001:db8:230:xx::1 remote-as 64496
 neighbor 2001:db8:230:xx::1 peer-group upstream-v6
 address-family ipv6 unicast
  neighbor upstream-v6 activate
  neighbor upstream-v6 soft-reconfiguration inbound
  neighbor upstream-v6 route-map upstream-in in
  neighbor upstream-v6 route-map upstream-out out
 exit-address-family
 !
 route-map upstream-out deny 100
 !
 route-map upstream-in permit 100
 !
\end{verbatim}
\end{minipage}

\begin{minipage}{\textwidth}
\subsubsection{Configure Peering (IPv4 and IPv6)}
\begin{verbatim}
router bgp 645xx
 bgp ebgp-requires-policy
 no bgp default ipv4-unicast
 neighbor peering-v4 peer-group
 neighbor peering-v6 peer-group
 neighbor 80.81.192.1 remote-as 286
 neighbor 80.81.192.1 peer-group peering-v4
 neighbor 80.81.192.1yy remote-as 645yy
 neighbor 80.81.192.1yy peer-group peering-v4
 ...
 neighbor 2001:7f8::1 remote-as 286
 neighbor 2001:7f8::1 peer-group peering-v6
 neighbor 2001:7f8::fbf5:0:1 remote-as 64501
 neighbor 2001:7f8::fbf5:0:1 peer-group peering-v6
 neighbor 2001:7f8::fbf6:0:1 remote-as 64502
 neighbor 2001:7f8::fbf6:0:1 peer-group peering-v6
 ...
 address-family ipv4 unicast
  neighbor peering-v4 activate
  neighbor peering-v4 soft-reconfiguration inbound
  neighbor peering-v4 route-map peering-in in
  neighbor peering-v4 route-map peering-out out
 exit-address-family
 address-family ipv6 unicast
  neighbor peering-v6 activate
  neighbor peering-v6 soft-reconfiguration inbound
  neighbor peering-v6 route-map peering-in in
  neighbor peering-v6 route-map peering-out out
 exit-address-family
!
route-map peering-in permit 100
!
route-map peering-out deny 100
!
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Announce an IPv4 and IPv6 prefix}
Be careful - this does not work on Cisco routers. While FRRouting needs separate route-map statements for IPv4 and IPv6, Cisco wants both \emph{match} clauses in one route-map statement.

\begin{verbatim}
ip route 192.168.nn.0/24 dummy0
ipv6 route 2001:db7:nnnn::/48 dummy0
!
router bgp 645xx
 address-family ipv4 unicast
  network 192.168.nn.0/24
 address-family ipv6 unicast
  network 2001:db7:nnnn::/48
!
ip prefix-list my-prefixes permit 192.168.nn.0/24
!
ipv6 prefix-list my-prefixes permit 2001:db7:nnnn::/48
!
route-map peering-out permit 50
 match ip address prefix-list my-prefixes
!
route-map peering-out permit 60
 match ipv6 address prefix-list my-prefixes
!
route-map upstream-out permit 50
 match ip address prefix-list my-prefixes
!
route-map upstream-out permit 60
 match ipv6 address prefix-list my-prefixes

\end{verbatim}
\end{minipage}

\begin{minipage}{\textwidth}
\subsubsection{Prefer peering over upstream}
We set the local preference in the incoming route map:
\begin{verbatim}
  route-map upstream-in permit 100
   set local-preference 10
  !
  route-map peering-in permit 100
   set local-preference 1000
\end{verbatim}
\end{minipage}
\subsection{Solution for Juniper}
\begin{minipage}{\textwidth}
\subsubsection{Configure two upstreams (IPv4 and IPv6)}
\begin{verbatim}
  protocols {
    bgp {
      local-as 645xx;
      group upstream-v4 {
        import upstream-in;
        family inet {
          unicast;
        }
        export upstream-out;
        neighbor 10.200.x.1 {
          peer-as 65550;
        }
        neighbor 10.230.x.1 {
          peer-as 64496;
        }
      }
      group upstream-v6 {
        import upstream-in;
        family inet6 {
          unicast;
        }
        export upstream-out;
        neighbor 2001:db8:200:x::1 {
          peer-as 65550;
        }
        neighbor 2001:db8:230:x::1 {
          peer-as 64496;
        }
      }
    }
  }
  policy-options {
    policy-statement upstream-in {
      then accept;
    }
    policy-statement upstream-out {
      then reject;
    }
  } 
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Configure Peering (IPv4 and IPv6)}
\begin{verbatim}
  protocols {
    bgp {
      local-as 645xx;
      group peering-v4 {
        import peering-in;
        family inet {
          unicast;
        }
        export peering-out;
        neighbor 80.81.192.1 {
          peer-as 286;
        }
        neighbor 80.81.192.1yy {
          peer-as 645yy;
        }
        ...
      }
      group peering-v6 {
        import peering-in;
        family inet6 {
          unicast;
        }
        export peering-out;
        neighbor 2001:7f8::1 {
          peer-as 286;
        }
        neighbor 2001:7f8::fbf5:0:1 {
          peer-as 64501;
        }
        neighbor 2001:7f8::fbf6:0:1 {
          peer-as 64502;
        }
        ...
      }
    }
  }
  policy-options {
    policy-statement peering-in {
      then accept;
    }
    policy-statement peering-out {
      then reject;
    }
  } 
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Announce an IPv4 and IPv6 prefix}
Syntax has been checked, but not functionality.
\begin{verbatim}
  routing-options {
    rib inet6.0 {
      aggregate {
          route 2001:db7:2::/48 discard;
      }
    }
    aggregate {
        route 192.168.2.0/24 discard;
    }
    autonomous-system 64500;
  }
  policy-options {
    policy-statement upstream-out {
        term aggr {
            from protocol aggregate;
            then accept;
        }
        then reject;
    }
    policy-statement peering-out {
        term aggr {
            from protocol aggregate;
            then accept;
        }
        then reject;
    }
  }
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Prefer peering over upstream}
\begin{verbatim}
  policy-options {
    policy-statement peering-in {
        then {
            local-preference 1000;
            accept;
        }
    }
    policy-statement upstream-in {
        then {
            local-preference 10;
            accept;
        }
    }
  }
\end{verbatim}
\end{minipage}

\subsection{Solution for Mikrotik}
\begin{minipage}{\textwidth}
\subsubsection{Configure two upstreams (IPv4 and IPv6)}
\begin{verbatim}
  /system identity
  set name=r0x
  
  /routing bgp instance
  set default as=645xx router-id=172.16.1.x
  
  /routing bgp peer
  add in-filter=upstream-in name=upstreamA-v4 out-filter=upstream-out \
      remote-address=10.200.x.1 remote-as=65550
  add in-filter=upstream-in name=upstreamB-v4 out-filter=upstream-out \
      remote-address=10.230.x.1 remote-as=64496
      
  add address-families=ipv6 in-filter=upstream-in name=upstreamA-v6 out-filter=\
      upstream-out remote-address=2001:db8:200:x::1 remote-as=65550
  add address-families=ipv6 in-filter=upstream-in name=upstreamB-v6 out-filter=\
      upstream-out remote-address=2001:db8:230:x::1 remote-as=64496
 
  /routing filter
  add action=discard chain=upstream-out
  add action=accept chain=upstream-in  

\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Configure Peering (IPv4 and IPv6)}
\begin{verbatim}
  /routing bgp instance
  add in-filter=peering-in name=peering286-v4 out-filter=peering-out \
      remote-address=80.81.192.1 remote-as=286
  add in-filter=peering-in name=peering645yy-v4 out-filter=peering-out \
      remote-address=80.81.192.1yy remote-as=645yy
  ...
  add address-families=ipv6 in-filter=peering-in name=peering286-v6 out-filter=peering-out \
      remote-address=2001:7f8::1 remote-as=286
  add address-families=ipv6 in-filter=peering-in name=peering64501-v6 out-filter=peering-out \
      remote-address=2001:7f8::fbf5:0:1 remote-as=64501
  add address-families=ipv6 in-filter=peering-in name=peering64502-v6 out-filter=peering-out \
      remote-address=2001:7f8::fbf6:0:1 remote-as=64502
  ...

  /routing filter
  add action=discard chain=peering-out
  add action=accept chain=peering-in  
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Announce an IPv4 and IPv6 prefix}
\begin{verbatim}
/ip route
add distance=1 dst-address=192.168.nn.0/24 gateway=loopback0

/ipv6 route
add distance=1 dst-address=2001:db7:nnnn::/48 gateway=loopback0

/routing filter
add action=accept address-family=ip chain=my-prefixes prefix=192.168.nn.0/24
add action=accept address-family=ipv6 chain=my-prefixes prefix=2001:db7:nnnn::/48
add action=return chain=my-prefixes

add chain=upstream-out place-before=1 action=jump jump-target=my-prefixes
add chain=peering-out place-before=1 action=jump jump-target=my-prefixes

/routing bgp instance
set default redistribute-static=yes

\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Prefer peering over upstream}
\begin{verbatim}
/routing filter
add action=passthrough place-before=1 chain=upstream-in set-bgp-local-pref=10
add action=passthrough place-before=1 chain=peering-in set-bgp-local-pref=1000
\end{verbatim}
\end{minipage}
\iffalse
\subsection{Solution for Cisco IOS}
\begin{minipage}{\textwidth}
\subsubsection{Configure two upstreams (IPv4 and IPv6)}
\begin{verbatim}
  
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Configure Peering (IPv4 and IPv6)}
\begin{verbatim}
  
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Announce an IPv4 and IPv6 prefix}
\begin{verbatim}
  
\end{verbatim}
\end{minipage}
\begin{minipage}{\textwidth}
\subsubsection{Prefer peering over upstream}
\begin{verbatim}
  
\end{verbatim}
\end{minipage}
\fi
\end{document}
